#include <string>
namespace slg { namespace ocl {
std::string KernelSource_materialdefs_funcs_null = 
"#line 2 \"materialdefs_funcs_null.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2018 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// NULL material\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#if defined (PARAM_ENABLE_MAT_NULL)\n"
"\n"
"BSDFEvent NullMaterial_GetEventTypes() {\n"
"	return SPECULAR | TRANSMIT;\n"
"}\n"
"\n"
"bool NullMaterial_IsDelta() {\n"
"	return true;\n"
"}\n"
"\n"
"#if defined(PARAM_HAS_PASSTHROUGH)\n"
"float3 NullMaterial_GetPassThroughTransparency(__global const Material *material,\n"
"		__global HitPoint *hitPoint, const float3 localFixedDir, const float passThroughEvent\n"
"		TEXTURES_PARAM_DECL) {\n"
"	const uint transpTexIndex = material->transpTexIndex;\n"
"\n"
"	if (transpTexIndex != NULL_INDEX) {\n"
"		const float3 blendColor = clamp(\n"
"			Texture_GetSpectrumValue(transpTexIndex, hitPoint\n"
"				TEXTURES_PARAM),\n"
"			0.f, 1.f);\n"
"\n"
"		if (Spectrum_IsBlack(blendColor)) {\n"
"			// It doesn't make any sense to have a solid NULL material\n"
"			return .0001f;\n"
"		} else\n"
"			return blendColor;\n"
"	} else\n"
"		return WHITE;\n"
"}\n"
"#endif\n"
"\n"
"float3 NullMaterial_Evaluate(\n"
"		__global HitPoint *hitPoint, const float3 lightDir, const float3 eyeDir,\n"
"		BSDFEvent *event, float *directPdfW) {\n"
"	return BLACK;\n"
"}\n"
"\n"
"float3 NullMaterial_Sample(\n"
"		__global HitPoint *hitPoint, const float3 fixedDir, float3 *sampledDir,\n"
"		const float u0, const float u1,\n"
"#if defined(PARAM_HAS_PASSTHROUGH)\n"
"		const float passThroughEvent,\n"
"#endif\n"
"		float *pdfW, float *cosSampledDir, BSDFEvent *event,\n"
"		const BSDFEvent requestedEvent) {\n"
"	if (!(requestedEvent & (SPECULAR | TRANSMIT)))\n"
"		return BLACK;\n"
"\n"
"	*sampledDir = -fixedDir;\n"
"	*cosSampledDir = 1.f;\n"
"\n"
"	*pdfW = 1.f;\n"
"	*event = SPECULAR | TRANSMIT;\n"
"	return WHITE;\n"
"}\n"
"\n"
"#endif\n"
; } }
